package rejtveny;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class Rejtveny {

	public static void main(String[] args) {
		try {
			//1. feladat - egy torony nehz-e
			
			BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			System.out.println("1. feladat: Adja meg egy torony sor, oszlop szmt s rtkt szkzzel elvlasztva: ");
			
			String[] egysor = br.readLine().split(" ");
			Hely adott = new Hely(Integer.parseInt(egysor[0]), Integer.parseInt(egysor[1]), Integer.parseInt(egysor[2]), false);
			
			if (adott.getErtek() > 3) {
				System.out.println("Nehz torony");
			}

			//2. feladat - krltte lev helyek
			
			System.out.println("2. feladat: ");
			for (int i = -1; i < 2; i++) {
				for (int j = -1; j < 2; j++) {
					if ((i != 0 || j != 0)												//nem nmaga
							&& adott.getSor() + i > 0 && adott.getSor() + i < 11 		//s a tbln bell
							&& adott.getOszlop() + j > 0 && adott.getOszlop() + j < 11) 
					{
						System.out.println((adott.getSor() + i) + ", " + (adott.getOszlop() + j));
					}
				}
			}

			//feladvny beolvassa
			
			BufferedReader fr = new BufferedReader(new FileReader("feladvany.txt"));
			String[] sorok = new String[10];
			int sorsz = 0;
			String adat;
			while ((adat = fr.readLine()) != null) {			
				sorok[sorsz] = adat;
				sorsz++;
			}
			Tabla feladvany = new Tabla("feladvany", sorok);
			fr.close();

			//megoldsok beolvassa
			
			fr = new BufferedReader(new FileReader("megoldas.txt"));
			int db = Integer.parseInt(fr.readLine());
			ArrayList<Tabla> megoldok = new ArrayList<Tabla>();
			//alternatv megolds
			// Tabla[] megoldok = new Tabla[db];		
			for (int i = 0; i < db; i++) {
				String neve = fr.readLine();
				for (int si = 0; si < 10; si++) {
					sorok[si] = fr.readLine();
				}
				// megoldok[i] = new Tabla(neve, sorok);
				megoldok.add(new Tabla(neve, sorok));
			}

			// 3. feladat - az aktulis ht megoldsa?
			
			System.out.println("3. feladat: Nem aktulis megoldsok bekldi:");
			int rosszHetDb = 0;
			ArrayList<Tabla> hetiMo = new ArrayList<Tabla>(); 	// 4. feladat elksztse
			for (Tabla tabla : megoldok) {
				boolean eHeti = true;	
				if (tabla.Torony().size() != feladvany.Torony().size()) {
					eHeti = false;
				} else {
					int ti = 0;
					while (ti < tabla.Torony().size() && true) {
						if ((tabla.Torony().get(ti).compareTo(feladvany.Torony().get(ti))) != 0) {
							eHeti = false;
						}
						ti++;
					}
				}
				if (!eHeti) {
					rosszHetDb++;
					System.out.print(tabla.getNev() + " ");
				} else {
					hetiMo.add(tabla);
				}
			}
			if (rosszHetDb == 0) {
				System.out.print("Mindegyik megolds erre a heti feladvnyra rkezett.");
			}
			System.out.println("");

			// 4. feladat - hibs a hajk szma
			
			System.out.println("4. feladat: Nem megfelel szm hajt bejellk szma:");
			int rosszHajoDb = 0;
			ArrayList<Tabla> hetiHajo12 = new ArrayList<Tabla>(); 	// 5. feladat elksztse		
			for (Tabla tabla : hetiMo) {
				if (tabla.Hajo().size() != 12) {
					rosszHajoDb++;
				} else {
					hetiHajo12.add(tabla);
				}
			}
			System.out.println(rosszHajoDb + " db");

			// 5. feladat - j a halyk elhelyezse
			
			System.out.println("5. feladat: elhelyezsi hibs megoldsok szma:");
			int rosszSzomszed = 0;
			ArrayList<Tabla> joMo = new ArrayList<Tabla>(); 		// 6. feladat elksztse			
			for (Tabla tabla : hetiHajo12) {
				if (tabla.JoHelyenDb() != 12) {
					rosszSzomszed++;
				} else {
					joMo.add(tabla);
				}
			}
			System.out.println(rosszSzomszed + " db");

			// 6. feladat - j megoldsok kirsa
			
			System.out.println("6. feladat: helyes megoldst bekldk:");
			for (Tabla tabla : joMo) {
				if (tabla.MindJo()) {
					System.out.println(tabla.getNev());
				}
			}

		} catch (Exception e) {						//illene minden IO-ra kln
			System.err.println(e.getMessage());
		}
	}
}
